function parallaxInit() {
	mgsjQuery('.parallax').parallax("30%", 0.1);
}

function initSlider(el,number,aplay,stophv,nav,pag){
	mgsjQuery("#"+el).owlCarousel({
		items : number,
		lazyLoad : true,
		navigation : nav,
		pagination : pag,
		autoPlay: aplay,
		stopOnHover: stophv,
		navigationText: ["<i class='fa fa-long-arrow-left'></i>","<i class='fa fa-long-arrow-right'></i>"],
		itemsDesktop: [1199,number],
		itemsDesktopSmall: [970,number],
		itemsTablet: [768,2],
		itemsTabletSmall: false,
		itemsMobile: [480,1],
		itemsCustom: false
	}); 
}

function socialSlider(el,number){
	mgsjQuery("#"+el).owlCarousel({
		items : number,
		lazyLoad : true,
		navigation : true,
		pagination : false,
		autoPlay: true,
		stopOnHover: true,
		navigationText: ["<i class='fa fa-angle-left'></i>","<i class='fa fa-angle-right'></i>"],
		itemsDesktop: [1199,number],
		itemsDesktopSmall: [970,number],
		itemsTablet: [768,2],
		itemsTabletSmall: false,
		itemsMobile: [480,1],
		itemsCustom: false
	}); 
}
function toggleEl(el){
	//mgsjQuery('.toggle-el').hide();
	mgsjQuery('#'+el).slideToggle('fast');
}

function initThemeJs(){
	// init tooltip
	mgsjQuery('.tooltip-links').tooltip({
		selector: "[data-toggle=tooltip]",
		container: "body"
	});
}

mgsjQuery(window).load(function() {
	mgsjQuery(window).bind('body', function() {
		parallaxInit();
	});
	
	var $container = mgsjQuery('.masonry-grid');
	// initialize
	$container.masonry({
	  itemSelector: '.item'
	});
	
	initThemeJs();
	
	if(mgsjQuery('.scroll-to-top').length){
		mgsjQuery(window).scroll(function(){
			if (mgsjQuery(this).scrollTop() > 1) {
				mgsjQuery('.scroll-to-top').css({bottom:"25px"});
			} else {
				mgsjQuery('.scroll-to-top').css({bottom:"-100px"});
			}
		});

		mgsjQuery('.scroll-to-top').click(function(){
			mgsjQuery('html, body').animate({scrollTop: '0px'}, 800);
			return false;
		});
	}
	mgsjQuery( ".products-grid.product-v1 .product-item-grid .product-meta.has-brand" ).each(function( index ) {
		var width = mgsjQuery(this).width();
		var widthMeta = mgsjQuery(this).find('.product-brand').width();
		if(widthMeta + 100 > width){
			mgsjQuery(this).addClass('no-float');
		}
	});
	if(mgsjQuery(width).width() > 1199){
		mgsjQuery(".main-header-7 .main-content-dark").height(mgsjQuery(".main-header-7").height());
		mgsjQuery(".main-header-7 .sidebar-dark").height(mgsjQuery(".main-header-7").height());
	}
});

/* MEGAMENU */
mgsjQuery(document).ready(function(){
	mgsjQuery(".product-view .product-shop .go-reviews").click(function (event) {
        event.preventDefault();
        mgsjQuery("#product_tabs .tab-content .active").removeClass("active");
        mgsjQuery("#product_tabs .nav-tabs .active").removeClass("active");
        mgsjQuery("#product_tabs #box-reviews").addClass("active");
        mgsjQuery("#product_tabs #tab-reviews").addClass("active");
        mgsjQuery('html, body').animate({
            scrollTop: mgsjQuery("#product_tabs").offset().top
        }, 1000);
    });
	mgsjQuery('.header-dropdown .social-login-link').click(function(){
		if(mgsjQuery(window).width() < 992){
			mgsjQuery(this).toggleClass('open');
		}
	});
	/* Remove class open when click cart */
	mgsjQuery('.minicart-wrapper .action.showcart').click(function(){
		var $elements = mgsjQuery('.minicart-wrapper');
		if(!$elements.hasClass('open')){
			mgsjQuery('#closed-minicart').addClass('open');
		}
		removeOpen($elements);
	});
	/* Show search */
	mgsjQuery('#btn-open-search').click(function(){
		var $elements = mgsjQuery('.search-form');
		removeOpen($elements);
	});
	/* Show form register when click */
	mgsjQuery('.register-dropdown > li > a').click(function(){
		var $elements = mgsjQuery('.register-dropdown');
		removeOpen($elements);
	});
	/* Show my account (Top header) when click */
	mgsjQuery('.top-dropdown.account-dropdown > a').click(function(){
		var $elements = mgsjQuery('.top-dropdown.account-dropdown');
		removeOpen($elements);
	});
	/* Show account dropdown when click */
	mgsjQuery('.account-dropdown > li > a').click(function(){
		var $elements = mgsjQuery('.account-dropdown');
		removeOpen($elements);
	});
	/* Show currency dropdown when click */
	mgsjQuery('.top-currency > a').click(function(){
		var $elements = mgsjQuery('.top-currency');
		removeOpen($elements);
	});
	/* Show language dropdown when click */
	mgsjQuery('.top-language > a').click(function(){
		var $elements = mgsjQuery('.top-language');
		removeOpen($elements);
	});
	/* Show language/currency dropdown when click */
	mgsjQuery('.currency-language > li > a').click(function(){
		var $elements = mgsjQuery('.currency-language');
		removeOpen($elements);
	});
	/* Show language/currency dropdown when click (Reponsive) */
	mgsjQuery('.header-dropdown.currency-language > li > ul > li').click(function(){
		if(mgsjQuery(this).hasClass('open')){
			mgsjQuery('.header-dropdown.currency-language > li > ul > li').removeClass('open');
		}else {
			mgsjQuery('.header-dropdown.currency-language > li > ul > li').removeClass('open');
			mgsjQuery(this).addClass('open');
		}
	});
	// Sticky Menu
	var height_header = mgsjQuery('header').height();
	var check_height = mgsjQuery(window).height();
	var body_height = mgsjQuery('body').height() - 250 -  height_header;
	if(body_height > check_height){
		mgsjQuery(window).scroll(function(){
			if(mgsjQuery(this).scrollTop() > 200 & mgsjQuery(this).width() > 991){	
				mgsjQuery('header .sticky-menu').addClass('active-sticky');
			}else {
				mgsjQuery('header .sticky-menu').removeClass('active-sticky');
			}
		});
	}
	/* Top Header Login */
	mgsjQuery('.top-dropdown.register-dropdown > a').click(function(){
		var $elements = mgsjQuery('.top-dropdown.register-dropdown');
		removeOpen($elements);
	});
	var current = 0;
	mgsjQuery('ul.mega-menu li').hover(function(){
		if(mgsjQuery(window).width() > 991){
			mgsjQuery(this).addClass("open");
		}
	}, function(){
		if(mgsjQuery(window).width() > 991){
			mgsjQuery(this).removeClass("open");
		}
	});
	mgsjQuery('.menu-container #closed-menu button').click(function(){
		mgsjQuery('.menu-container').removeClass('active');
	});
	mgsjQuery('#show-menu-responsive').click(function(){
		mgsjQuery('.menu-container').toggleClass('active');
	});
	mgsjQuery('#mainMenu li .toggle-menu > a').click(function(){
		current++;
		mgsjQuery('#heading-back').show();
		var title = "";
		title = mgsjQuery(this).parent().parent().find('> a').text();
		classCss = "lv" + current;
		mgsjQuery('#heading-back > span').empty();
		mgsjQuery('#heading-back > span').html(title);
		mgsjQuery('#mainMenu ul').removeClass('current-show');
		mgsjQuery(this).parent().parent().find('> ul').addClass(classCss)
		mgsjQuery(this).parent().parent().find('> ul').addClass('active-now');
		mgsjQuery(this).parent().parent().find('> ul').addClass('current-show');
		var height = mgsjQuery(window).height() - 53;
		mgsjQuery('#mainMenu ul.current-show.active-now').css('max-height', height);
		mgsjQuery('#mainMenu').height(height);
	});
	mgsjQuery('#heading-back').click(function(){
		var height = mgsjQuery(window).height() - 53;
		classCssCurrent = "lv" + current;
		mgsjQuery("#mainMenu ul.current-show.active-now").removeAttr("style");
		mgsjQuery("#mainMenu ul.current-show.active-now").removeClass(classCssCurrent);
		mgsjQuery('#mainMenu ul.current-show').removeClass('active-now');
		mgsjQuery('#mainMenu ul.current-show').removeClass('current-show');
		current--;
		classCss = ".lv" + current;
		nextClass = ".mega-menu ul.active-now" + classCss;
		if(current <= 0){
			mgsjQuery(this).hide()
		}else if(current > 0){
			var title = "";
			title =  mgsjQuery(nextClass).parent().find('> a').text();
			mgsjQuery('#heading-back > span').empty();
			mgsjQuery('#heading-back > span').html(title);
		}
		mgsjQuery(nextClass).addClass('current-show');
		mgsjQuery('#mainMenu ul.current-show.active-now').css('max-height', height);
		mgsjQuery('#mainMenu').height(height);
	});
	mgsjQuery('.horizontal-menu .toggle-menu').click(function(){
		mgsjQuery(this).toggleClass('active');
		mgsjQuery(this).parent().find('> ul').slideToggle('fast');
	});
	mgsjQuery('#show-menu-custom').click(function(){
		mgsjQuery('.horizontal-menu').slideToggle('fast');
	});
	
	mgsjQuery("body").on("click",".products-grid .product-item-grid", function(){
		mgsjQuery('.products-grid .product-item-grid').removeClass('current');
		mgsjQuery(this).addClass('current');
	});
	

	mgsjQuery(".sidebar .vertical-menu li.active > ul").css("display","block");
	mgsjQuery(".sidebar .vertical-menu li.active > .toggle-icon > a").addClass("collapse");
	
	
});


mgsjQuery(window).resize(function(){
	var height = mgsjQuery(window).height() - 53;
	mgsjQuery('#mainMenu ul.current-show.active-now').css('max-height', height);
	if(mgsjQuery(window).width() < 768){
		mgsjQuery('#mainMenu').height(height);
	}else {
		mgsjQuery('#mainMenu').removeAttr("style");
	}
	if(mgsjQuery(this).width() > 991){
		mgsjQuery('#mainMenu ul').removeAttr("style");
	}
	mgsjQuery( ".products-grid.product-v1 .product-item-grid .product-meta.has-brand" ).each(function( index ) {
		mgsjQuery(this).removeClass('no-float');
		var width = mgsjQuery(this).width();
		var widthMeta = mgsjQuery(this).find('.product-brand').width();
		if(widthMeta + 100 > width){
			mgsjQuery(this).addClass('no-float');
		}
	});
	
	mgsjQuery(".products-grid.product-v5 .item").each(function( index ) {
		mgsjQuery(this).removeClass('mini-button');
		var width_v5 = mgsjQuery(this).width();
		var width_subv5 = mgsjQuery(this).find('.product-actions').width();
		if(width_subv5 + 30 >= width_v5){
			mgsjQuery(this).addClass('mini-button');
		}
	});
	if(mgsjQuery(window).width() > 1199){
		mgsjQuery(".main-header-7 .main-content-dark").height(mgsjQuery(".main-header-7").height());
		mgsjQuery(".main-header-7 .sidebar-dark").height(mgsjQuery(".main-header-7").height());
	}else{
		mgsjQuery(".main-header-7 .main-content-dark").removeAttr("style");
		mgsjQuery(".main-header-7 .sidebar-dark").removeAttr("style");
	}
});
/* END MEGAMENU */
// init gmap
function initGmap(address, html, image){
	mgsjQuery.ajax({
		type: "GET",
		dataType: "json",
		url: "https://maps.googleapis.com/maps/api/geocode/json",
		data: {'address': address,'sensor':false},
		success: function(data){
			if(data.results.length){
				latitude = data.results[0].geometry.location.lat;
				longitude = data.results[0].geometry.location.lng;
				
				var locations = [
			[html, latitude, longitude, 2]
			];
		
			var map = new google.maps.Map(document.getElementById('map-contact'), {
			  zoom: 14,
				scrollwheel: false,
				navigationControl: true,
				mapTypeControl: false,
				scaleControl: false,
				draggable: true,
				center: new google.maps.LatLng(latitude, longitude),
			  mapTypeId: google.maps.MapTypeId.ROADMAP
			});
		
			var infowindow = new google.maps.InfoWindow();
		
			var marker, i;
		
			for (i = 0; i < locations.length; i++) {  
		  
				marker = new google.maps.Marker({ 
				position: new google.maps.LatLng(locations[i][1], locations[i][2]), 
				map: map ,
				icon: image
				});
		
		
			  google.maps.event.addListener(marker, 'click', (function(marker, i) {
				return function() {
				  infowindow.setContent(locations[i][0]);
				  infowindow.open(map, marker);
				}
			  })(marker, i));
			}
			}
		}
	});
}

var newCount = 2;
var hotCount = 2;
var featuredCount = 2;
var saleCount = 2;
var rateCount = 2;

// load more products
function loadMore(count, type, productCount, perRow){
	mgsjQuery('#'+type+'_loadmore_button .btn-loadmore').addClass('on-load');
	var request = new Ajax.Request(WEB_URL+'mpanel/loadmore/'+type+'?perrow='+perRow+'&p='+count+'&limit='+productCount, {
		onSuccess: function(response) {
			result = response.responseText;
			mgsjQuery('#'+type+'_product_container').append(result);
			mgsjQuery('#'+type+'_loadmore_button .btn-loadmore').removeClass('on-load');
			initThemeJs();
		}
	});
}

// open overlay popup
function openOverlay(){
	mgsjQuery('#theme-popup').show();
}

// close overlay popup
function closeOverlay(){
	mgsjQuery('#theme-popup').hide();
}

var active = false;
var data = "";

// Price slider
function sliderAjax(url) {
	if (!active) {
		active = true;
		openOverlay();		
		oldUrl = url;
		try {
			mgsjQuery.ajax({
				url: url,
				dataType: 'json',
				type: 'post',
				data: data,
				success: function(data) {
					if (data.leftcontent) {
						if (mgsjQuery('.block-layered-nav')) {
							mgsjQuery('.block-layered-nav').empty();
							mgsjQuery('.block-layered-nav').append(data.leftcontent);
						}
					}
					if (data.maincontent) {
						mgsjQuery('#product-list-container').empty();
						mgsjQuery('#product-list-container').append(data.maincontent);
					}
					var hist = url.split('?');
					if(window.history && window.history.pushState){
						window.history.pushState('GET', data.title, url);
					}
					initThemeJs();
					closeOverlay();
				}
			});
		} catch (e) {}

		active = false;
	}
	return false;
}


// Ajax catalog load
function shopMore(url) {
	oldHtml = mgsjQuery('.category-products ul.products-grid').html();
	openOverlay();
	oldUrl = url;
	try {
		mgsjQuery.ajax({
			url: url,
			dataType: 'json',
			type: 'post',
			data: data,
			success: function(data) {
				if (data.leftcontent) {
					if (mgsjQuery('.block-layered-nav')) {
						mgsjQuery('.block-layered-nav').empty();
						mgsjQuery('.block-layered-nav').append(data.leftcontent);
					}
				}
				if (data.maincontent) {
					mgsjQuery('#product-list-container').empty();
					mgsjQuery('#product-list-container').append(data.maincontent);
					mgsjQuery('.category-products ul.products-grid').prepend(oldHtml);
				}
				initThemeJs();
				closeOverlay();
				mgsjQuery(".products-grid.product-v5 .item").each(function( index ) {
					mgsjQuery(this).removeClass('mini-button');
					var width_v5 = mgsjQuery(this).width();
					var width_subv5 = mgsjQuery(this).find('.product-actions').width();
					if(width_subv5 + 30 >= width_v5){
						mgsjQuery(this).addClass('mini-button');
					}
				});
			}
		});
	} catch (e) {}
}

function openSidebar(){
	mgsjQuery('.sidebar .block.opc-block-progress').addClass('open');
}
function closeSidebar(){
	mgsjQuery('.sidebar .block.opc-block-progress').removeClass('open');
}
function getCookie(cname) {
    var name = cname + "=";
    var ca = document.cookie.split(';');
    for(var i=0; i<ca.length; i++) {
        var c = ca[i];
        while (c.charAt(0)==' ') c = c.substring(1);
        if (c.indexOf(name) == 0) return c.substring(name.length,c.length);
    }
    return "";
} 

function positionSidebar(){
	if(mgsjQuery(window).width() < 992 && mgsjQuery(window).width() > 767){
		var height1 = mgsjQuery('.three_columns_page .col-left.sidebar').height();
		var height2 = mgsjQuery('.three_columns_page .col-right.sidebar').height();
		if(height1 >= height2){
			mgsjQuery('.three_columns_page .col-left.sidebar').removeClass('min-height');
			mgsjQuery('.three_columns_page .col-right.sidebar').addClass('min-height');
		}else {
			mgsjQuery('.three_columns_page .col-right.sidebar').removeClass('min-height');
			mgsjQuery('.three_columns_page .col-left.sidebar').addClass('min-height');
		}
	}
}

function dontShowPopup(el){
	if($(el).checked==true){
		var d = new Date();
		d.setTime(d.getTime() + (24*60*60*1000*365));
		var expires = "expires="+d.toUTCString();
		document.cookie = 'newsletterpopup' + "=" + 'nevershow' + "; " + expires;
	}else{
		document.cookie = 'newsletterpopup' + "= ''; -1";
	}
	
	
}
function closeMgs() {
	mgsjQuery.magnificPopup.close();
}

function removeOpen($elements) {
	var $elements1 = mgsjQuery('.currency-language');
	var $elements2 = mgsjQuery('.top-language');
	var $elements3 = mgsjQuery('.top-currency');
	var $elements4 = mgsjQuery('.register-dropdown');
	var $elements5 = mgsjQuery('.account-dropdown');
	var $elements6 = mgsjQuery('.top-dropdown.account-dropdown');
	var $elements7 = mgsjQuery('.minicart-wrapper');
	var $elements8 = mgsjQuery('.search-form');
	var $elements9 = mgsjQuery('.top-dropdown.register-dropdown');
	if(!$elements.is($elements1)){
		mgsjQuery('.currency-language').removeClass('open');
	}
	if(!$elements.is($elements2)){
		mgsjQuery('.top-language').removeClass('open');
	}
	if(!$elements.is($elements3)){
		mgsjQuery('.top-currency').removeClass('open');
	}
	if(!$elements.is($elements4)){
		mgsjQuery('.register-dropdown').removeClass('open');
	}
	if(!$elements.is($elements5)){
		mgsjQuery('.account-dropdown').removeClass('open');
	}
	if(!$elements.is($elements6)){
		mgsjQuery('.top-dropdown.account-dropdown').removeClass('open');
	}
	if(!$elements.is($elements7)){
		mgsjQuery('.minicart-wrapper').removeClass('open');
	}
	if(!$elements.is($elements8)){
		mgsjQuery('.search-form').removeClass('open');
	}
	if(!$elements.is($elements9)){
		mgsjQuery('.top-dropdown.register-dropdown').removeClass('open');
	}
	$elements.toggleClass('open');
}