<?php

class MGS_Abrands_Adminhtml_AbrandsController extends Mage_Adminhtml_Controller_Action
{

	protected function _initAction() {
		$this->loadLayout()
			->_setActiveMenu('mgscore/brands')
			->_addBreadcrumb(Mage::helper('adminhtml')->__('Items Manager'), Mage::helper('adminhtml')->__('Item Manager'));
		
		return $this;
	}   
 
	public function indexAction() {
		$this->_initAction();
		$this->_addContent($this->getLayout()->createBlock('abrands/adminhtml_abrands'));
		$this->renderLayout();
	}

	public function editAction() {
		$id     = $this->getRequest()->getParam('id');
		$model  = Mage::getModel('abrands/abrands')->load($id);

		if ($model->getId() || $id == 0) {
			$data = Mage::getSingleton('adminhtml/session')->getFormData(true);
			if (!empty($data)) {
				$model->setData($data);
			}

			Mage::register('abrands_data', $model);

			$this->loadLayout();
			$this->_setActiveMenu('mgscore/brands');

			$this->_addBreadcrumb(Mage::helper('adminhtml')->__('Item Manager'), Mage::helper('adminhtml')->__('Item Manager'));
			$this->_addBreadcrumb(Mage::helper('adminhtml')->__('Item News'), Mage::helper('adminhtml')->__('Item News'));

			$this->getLayout()->getBlock('head')->setCanLoadExtJs(true);

			$this->_addContent($this->getLayout()->createBlock('abrands/adminhtml_abrands_edit'))
				->_addLeft($this->getLayout()->createBlock('abrands/adminhtml_abrands_edit_tabs'));

			$this->renderLayout();
		} else {
			Mage::getSingleton('adminhtml/session')->addError(Mage::helper('abrands')->__('Item does not exist'));
			$this->_redirect('*/*/');
		}
	}
 
	public function newAction() {
		$this->_forward('edit');
	}
 
	public function saveAction() {
		if ($data = $this->getRequest()->getPost()) {
			if(isset($_FILES['filename']['name']) && $_FILES['filename']['name'] != '') {
				try {	
					/* Starting upload */	
					$uploader = new Varien_File_Uploader('filename');
					
					// Any extention would work
	           		$uploader->setAllowedExtensions(array('jpg','jpeg','gif','png'));
					$uploader->setAllowRenameFiles(false);
					
					// Set the file upload mode 
					// false -> get the file directly in the specified folder
					// true -> get the file in the product like folders 
					//	(file.jpg will go in something like /media/f/i/file.jpg)
					$uploader->setFilesDispersion(false);
							
					// We set media as the upload dir
					$path = Mage::getBaseDir('media') . DS . 'abrands' . DS;
					$result = $uploader->save($path, $_FILES['filename']['name'] );
					$data['filename'] = $result['file'];
					
				} catch (Exception $e) {
		      
		        }
			}
	  			
			$model = Mage::getModel('abrands/abrands');		
			$model->setData($data)
				->setId($this->getRequest()->getParam('id'));
			
			try {
				if ($model->getCreatedTime == NULL || $model->getUpdateTime() == NULL) {
					$model->setCreatedTime(now())
						->setUpdateTime(now());
				} else {
					$model->setUpdateTime(now());
				}	
				
				$model->save();
				Mage::getSingleton('adminhtml/session')->addSuccess(Mage::helper('abrands')->__('Item was successfully saved'));
				Mage::getSingleton('adminhtml/session')->setFormData(false);

				if ($this->getRequest()->getParam('back')) {
					$this->_redirect('*/*/edit', array('id' => $model->getId()));
					return;
				}
				$this->_redirect('*/*/');
				return;
            } catch (Exception $e) {
                Mage::getSingleton('adminhtml/session')->addError($e->getMessage());
                Mage::getSingleton('adminhtml/session')->setFormData($data);
                $this->_redirect('*/*/edit', array('id' => $this->getRequest()->getParam('id')));
                return;
            }
        }
        Mage::getSingleton('adminhtml/session')->addError(Mage::helper('abrands')->__('Unable to find item to save'));
        $this->_redirect('*/*/');
	}
 
	public function deleteAction() {
		if( $this->getRequest()->getParam('id') > 0 ) {
			try {
				$model = Mage::getModel('abrands/abrands');
				 
				$model->setId($this->getRequest()->getParam('id'))
					->delete();
					 
				Mage::getSingleton('adminhtml/session')->addSuccess(Mage::helper('adminhtml')->__('Item was successfully deleted'));
				$this->_redirect('*/*/');
			} catch (Exception $e) {
				Mage::getSingleton('adminhtml/session')->addError($e->getMessage());
				$this->_redirect('*/*/edit', array('id' => $this->getRequest()->getParam('id')));
			}
		}
		$this->_redirect('*/*/');
	}

    public function massDeleteAction() {
        $abrandsIds = $this->getRequest()->getParam('abrands');
        if(!is_array($abrandsIds)) {
			Mage::getSingleton('adminhtml/session')->addError(Mage::helper('adminhtml')->__('Please select item(s)'));
        } else {
            try {
                foreach ($abrandsIds as $abrandsId) {
                    $abrands = Mage::getModel('abrands/abrands')->load($abrandsId);
                    $abrands->delete();
                }
                Mage::getSingleton('adminhtml/session')->addSuccess(
                    Mage::helper('adminhtml')->__(
                        'Total of %d record(s) were successfully deleted', count($abrandsIds)
                    )
                );
            } catch (Exception $e) {
                Mage::getSingleton('adminhtml/session')->addError($e->getMessage());
            }
        }
        $this->_redirect('*/*/index');
    }
	
    public function massStatusAction()
    {
        $abrandsIds = $this->getRequest()->getParam('abrands');
        if(!is_array($abrandsIds)) {
            Mage::getSingleton('adminhtml/session')->addError($this->__('Please select item(s)'));
        } else {
            try {
                foreach ($abrandsIds as $abrandsId) {
                    $abrands = Mage::getSingleton('abrands/abrands')
                        ->load($abrandsId)
                        ->setStatus($this->getRequest()->getParam('status'))
                        ->setIsMassupdate(true)
                        ->save();
                }
                $this->_getSession()->addSuccess(
                    $this->__('Total of %d record(s) were successfully updated', count($abrandsIds))
                );
            } catch (Exception $e) {
                $this->_getSession()->addError($e->getMessage());
            }
        }
        $this->_redirect('*/*/index');
    }
  
    public function exportCsvAction()
    {
        $fileName   = 'abrands.csv';
        $content    = $this->getLayout()->createBlock('abrands/adminhtml_abrands_grid')
            ->getCsv();

        $this->_sendUploadResponse($fileName, $content);
    }

    public function exportXmlAction()
    {
        $fileName   = 'abrands.xml';
        $content    = $this->getLayout()->createBlock('abrands/adminhtml_abrands_grid')
            ->getXml();

        $this->_sendUploadResponse($fileName, $content);
    }

    protected function _sendUploadResponse($fileName, $content, $contentType='application/octet-stream')
    {
        $response = $this->getResponse();
        $response->setHeader('HTTP/1.1 200 OK','');
        $response->setHeader('Pragma', 'public', true);
        $response->setHeader('Cache-Control', 'must-revalidate, post-check=0, pre-check=0', true);
        $response->setHeader('Content-Disposition', 'attachment; filename='.$fileName);
        $response->setHeader('Last-Modified', date('r'));
        $response->setHeader('Accept-Ranges', 'bytes');
        $response->setHeader('Content-Length', strlen($content));
        $response->setHeader('Content-type', $contentType);
        $response->setBody($content);
        $response->sendResponse();
        die;
    }
	
	public function valueAction(){
		$arrParam=$this->getRequest()->getParams();

		$attribute = Mage::getModel('eav/entity_attribute')->getCollection()->addFieldToFilter('frontend_input','select');
		
		$arrExist = array();
		if($id = $this->getRequest()->getParam('id')){
			$brand = Mage::getModel('abrands/abrands')->load($id);
		}
		
		$collection = Mage::getModel('abrands/abrands')->getCollection();
		if(count($collection)>0){
			foreach($collection as $item){
				$arrExist[] = $item->getOptionId();
			}
		}
		
		if($this->getRequest()->getParam('id')){
			$curentOptionId = $brand->getOptionId();
			if(in_array($curentOptionId, $arrExist)){
				$key = array_search($curentOptionId, $arrExist);
				unset($arrExist[$key]);
			}
		}
		
		
		$code= array ();
		foreach ($attribute as $item) {
			$code[$item->getAttributeCode()]=$item->getFrontendLabel();  
		}
		
		foreach($arrParam as $key=>$value){
			if(array_key_exists($key,$code)){
				$val=$key;
				break;
			}
		}
		
		
		$attribute = Mage::getModel('eav/config')->getAttribute('catalog_product', $val); 
		$html = '';

		foreach ($attribute->getSource()->getAllOptions(true, true) as $options) {
				
			if(!in_array($options['value'], $arrExist)){
				$html .= '<option value="'.$options['value'].'"';
				
				if($this->getRequest()->getParam('id') && ($brand->getOptionId()==$options['value'])){
					$html .= ' selected="selected"';
				}
				
				$html .= '>'.$options["label"].'</option>';
			}

			
			
			

		}
		
		echo $html;
	}
}