<?php

/* * ****************************************************
 * Package   : AdvancedSearch
 * Author    : HIEPNH
 * Copyright : (c) 2014
 * ***************************************************** */
?>
<?php

class MGS_AdvancedSearch_Block_Form extends Mage_Core_Block_Template {

    protected function _construct() {
        $this->addData(array(
            'cache_lifetime' => false,
            'cache_tags' => array(Mage_Core_Model_Store::CACHE_TAG, Mage_Cms_Model_Block::CACHE_TAG)
        ));
    }

    public function getCurrentlySelectedCategoryId() {
        $helper = $this->helper('advancedsearch');
        if ($helper->isCategoryPage() && $helper->selectCategoryOnCategoryPages()) {
            foreach (Mage::getSingleton('catalog/layer')->getState()->getFilters() as $filterItem) {
                if ($filterItem->getFilter() instanceof Mage_Catalog_Model_Layer_Filter_Category) {
                    if ($filterItem->getFilter()->getCategory()->getLevel() <= $helper->getMaximumCategoryLevel()) {
                        return $filterItem->getValue();
                    }
                }
            }
            return Mage::getSingleton('catalog/layer')->getCurrentCategory()->getEntityId();
        }
        if ($helper->isSearchResultsPage()) {
            foreach (Mage::getSingleton('catalogsearch/layer')->getState()->getFilters() as $filterItem) {
                if ($filterItem->getFilter() instanceof Mage_Catalog_Model_Layer_Filter_Category) {
                    return $filterItem->getValue();
                }
            }
        }
        return Mage::app()->getStore()->getRootCategoryId();
    }

    public function getSearchableCategories() {
        $rootCategory = Mage::getModel('catalog/category')->load(Mage::app()->getStore()->getRootCategoryId());
        return $this->getSearchableSubCategories($rootCategory);
    }

    public function getSearchableSubCategories($category) {
        return Mage::getModel('catalog/category')->getCollection()
                        ->addAttributeToSelect('name')
                        ->addAttributeToSelect('all_children')
                        ->addAttributeToFilter('is_active', 1)
                        ->addAttributeToFilter('include_in_menu', 1)
                        ->addIdFilter($category->getChildren())
                        ->setOrder('position', 'ASC')
                        ->load();
    }

}
