<?php

class MGS_Portfolio_Helper_Data extends MGS_Mgscore_Helper_Data
{
	public function getThumbnail($portfolio){
		return Mage::getBaseUrl(Mage_Core_Model_Store::URL_TYPE_MEDIA).$portfolio->getThumbnailImage();
	}
	
	public function getBaseImage($portfolio){
		return Mage::getBaseUrl(Mage_Core_Model_Store::URL_TYPE_MEDIA).$portfolio->getBaseImage();
	}
	
	public function getCategories($portfolio){
		$collection = Mage::getModel('portfolio/stores')
			->getCollection()
			->addFieldToFilter('portfolio_id', $portfolio->getId());
		$catTable = Mage::getSingleton('core/resource')->getTableName('mgs_portfolio_category');
		$collection->getSelect()->joinLeft(array('cat'=>$catTable), 'main_table.category_id = cat.category_id', array('cat.category_name as name'));
		
		return $collection;
	}
	
	public function getCategoriesText($portfolio){
		$collection = $this->getCategories($portfolio);
		
		if(count($collection)>0){
			$arrResult = array();
			foreach($collection as $item){
				$arrResult[] = $item->getName();
			}
			return implode(', ', $arrResult);
		}
		return '';
	}
	
	public function getCategoriesLink($portfolio){
		$collection = $this->getCategories($portfolio);
		$html = '';
		if(count($collection)>0){
			$i=0;
			foreach($collection as $item){
				//print_r($item->getCategoryId());
				$cate = Mage::getModel('portfolio/category')->getCollection()->addFieldToFilter('category_id', array('eq' => $item->getCategoryId()))->getFirstItem();
				$i++;
				$html .= '<a href="'.Mage::getUrl('portfolios/').$cate->getIdentifier().'">'.$item->getName().'</a>';
				if($i<count($collection)){
					$html .= ', ';
				}
			}
		}
		return $html;
	}
	
	public function getRelatedPortfolio($portfolio){
		$collection = $this->getCategories($portfolio);
		if(count($collection)>0){
			$arrResult = array();
			foreach($collection as $item){
				$arrResult[] = $item->getCategoryId();
			}
			$catString = implode(', ', $arrResult);
			
			$portfolios = Mage::getModel('portfolio/portfolio')
				->getCollection()
				->addFieldToFilter('status', 1);
				
			if($catString != ''){
				$storeTable = Mage::getSingleton('core/resource')->getTableName('mgs_portfolio_category_items');
				$portfolios->getSelect()->distinct()->joinLeft(array('store'=>$storeTable), 'main_table.portfolio_id = store.portfolio_id', array(''))
					->where('category_id in ('.$catString.')')
					->where('main_table.portfolio_id <> '.$portfolio->getId());
			}
			return $portfolios;
		}
		return false;
	}
	
	public function getPortfolioUrl($portfolio = NUll) {
		return 'portfolios/'.$portfolio->getIdentifier();
	}
	
	public function getPortfoliosId(){
		$portfolios = Mage::getModel('portfolio/portfolio')
			->getCollection()
			->addFieldToFilter('status', 1);
		if(count($portfolios) > 0){
			$arrResult = array();
			foreach($portfolios as $item){
				$arrResult[] = $item->getPortfolioId();
			}
			return $arrResult;
		}
		return;
	}
	public function getUrlPortfoliosById($id){
		$portfolios = Mage::getModel('portfolio/portfolio')->load($id);
		$urlResult = Mage::getBaseUrl(Mage_Core_Model_Store::URL_TYPE_WEB) . $this->getPortfolioUrl($portfolios);
		return $urlResult;
	}
	public function getNextUrl($id){
		$arrId = $this->getPortfoliosId();
		if(is_array($arrId)){
			$maxKey = count($arrId) - 1;
			$key = array_search($id, $arrId);
			if($key == $maxKey){
				$nextKey = 0;
			}else {
				$nextKey = $key + 1;
			}
			$idNext = $arrId[$nextKey];
			return $this->getUrlPortfoliosById($idNext);
		}
		return;
	}
	public function getPrevUrl($id){
		$arrId = $this->getPortfoliosId();
		if(is_array($arrId)){
			$maxKey = count($arrId) - 1;
			$key = array_search($id, $arrId);
			if($key == 0){
				$nextKey = $maxKey;
			}else {
				$nextKey = $key - 1;
			}
			$idNext = $arrId[$nextKey];
			return $this->getUrlPortfoliosById($idNext);
		}
		return;
	}
}