<?php

namespace MGS\QuickView\Helper;

class Data extends \Magento\Framework\App\Helper\AbstractHelper {

    const XML_PATH_QUICKVIEW_ENABLED = 'mgs_quickview/general/enabled';
    const XML_PATH_QUICKVIEW_BUTTONSTYLE = 'mgs_quickview/general/button_style';

    public function aroundQuickViewHtml(\Magento\Catalog\Model\Product $product, $text = NULL) 
	{
        $result = '';
        $isEnabled = $this->scopeConfig->getValue(self::XML_PATH_QUICKVIEW_ENABLED, \Magento\Store\Model\ScopeInterface::SCOPE_STORE);
        if ($isEnabled) {
            $productUrl = $this->_urlBuilder->getUrl('mgs_quickview/catalog_product/view', array('id' => $product->getId()));
			$result .= '<button class="mgs-quickview btn-quickview" data-quickview-url=' . $productUrl . '"><span class="fa fa-search"></span>';
			if($text != NULL){
				$result .= '<span class="text">' . $text . '</span>';
			}
			$result .= '</button>';
        }
        return $result;
    }
}
