<?php

namespace MGS\Blog\Setup;

use Magento\Framework\Setup\UpgradeSchemaInterface;
use Magento\Framework\Setup\ModuleContextInterface;
use Magento\Framework\Setup\SchemaSetupInterface;

class UpgradeSchema implements UpgradeSchemaInterface
{
    public function upgrade(SchemaSetupInterface $setup, ModuleContextInterface $context)
    {
        $setup->startSetup();
        if (version_compare($context->getVersion(), '2.0.0', '<=')) {
            $setup->getConnection()->addColumn(
                $setup->getTable('mgs_blog_post'),
                'image',
                [
                    'type' => \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
                    'nullable' => true,
                    'default' => null,
                    'comment' => 'Image'
                ]
            );
        }
		
        if (version_compare($context->getVersion(), '2.0.1', '<=')) {
            $setup->getConnection()->addColumn(
                $setup->getTable('mgs_blog_post'),
				'thumb_type', [
					'type' => \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
					'length' => 50,
					'nullable' => true,
					'default' => '',
					'comment' => 'Thumbnail Type'
				]
            );
			$setup->getConnection()->addColumn(
                $setup->getTable('mgs_blog_post'),
				'video_thumb_type', [
					'type' => \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
					'length' => 50,
					'nullable' => true,
					'default' => '',
					'comment' => 'Video Thumbnail Type'
				]
            );
			$setup->getConnection()->addColumn(
                $setup->getTable('mgs_blog_post'),
				'video_thumb_id', [
					'type' => \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
					'length' => 50,
					'nullable' => true,
					'default' => '',
					'comment' => 'Video Thumbnail Id'
				]
            );
			
			$setup->getConnection()->addColumn(
                $setup->getTable('mgs_blog_post'),
				'image_type', [
					'type' => \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
					'length' => 50,
					'nullable' => true,
					'default' => '',
					'comment' => 'Image Type'
				]
            );
			$setup->getConnection()->addColumn(
                $setup->getTable('mgs_blog_post'),
				'video_big_type', [
					'type' => \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
					'length' => 50,
					'nullable' => true,
					'default' => '',
					'comment' => 'Video Big Type'
				]
            );
			$setup->getConnection()->addColumn(
                $setup->getTable('mgs_blog_post'),
				'video_big_id', [
					'type' => \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
					'length' => 50,
					'nullable' => true,
					'default' => '',
					'comment' => 'Video Big Id'
				]
            );
        }
		
		
        if (version_compare($context->getVersion(), '2.0.2', '<=')) {
            $setup->getConnection()->addColumn(
                $setup->getTable('mgs_blog_post'),
                'author_post',
                [
                    'type' => \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
					'length' => 150,
                    'nullable' => true,
                    'default' => null,
                    'comment' => 'Author create post'
                ]
            );
        }
        $setup->endSetup();
    }
}
