<?php
/**
 * Copyright © 2015 Magento. All rights reserved.
 * See COPYING.txt for license details.
 */
namespace MGS\Mmegamenu\Block;

/**
 * Main contact form block
 */
class Horizontal extends Abstractmenu
{
	public function getMegamenuItems(){
		$store = $this->getStore();
		$menuCollection = $this->getModel('MGS\Mmegamenu\Model\Mmegamenu')
			->getCollection()
			->addStoreFilter($store)
			->addFieldToFilter('parent_id', $this->getMenuId())
			->addFieldToFilter('status', 1)
			->setOrder('position', 'ASC')
		;
		return $menuCollection;
	}
	public function getMegamenuItemsLeft(){
		$menuCollection = $this->getMegamenuItems();
		$menuLeftCollection = array();
		foreach($menuCollection as $item){
			$class = $item->getSpecialClass();
			if(!strstr($class, 'rightlogo')){
				$menuLeftCollection[] = $item;
			}
		}
		return $menuLeftCollection;
	}
	public function getMegamenuItemsRight(){
		$menuCollection = $this->getMegamenuItems();
		$menuRightCollection = array();
		foreach($menuCollection as $item){
			$class = $item->getSpecialClass();
			if(strstr($class, 'rightlogo')){
				$menuRightCollection[] = $item;
			}
		}
		return $menuRightCollection;
	}
}

