<?php
/**
 * Copyright © 2015 Magento. All rights reserved.
 * See COPYING.txt for license details.
 */

namespace MGS\Portfolio\Helper;

/**
 * Contact base helper
 */
use Magento\Catalog\Model\Product\Gallery\ReadHandler as GalleryReadHandler;

class Data extends \Magento\Framework\App\Helper\AbstractHelper
{
	protected $galleryReadHandler;
	
	public function __construct(
        GalleryReadHandler $galleryReadHandler
    )
    {
        $this->galleryReadHandler = $galleryReadHandler;
    }

    /** Add image gallery to $product */
    public function addGallery($product)
    {
        $this->galleryReadHandler->execute($product);
    }
	
	/* Get col for responsive */
	public function getColClass($perrow){
		switch($perrow){
			case 2:
				return 'col-lg-6 col-md-6 col-sm-6 col-xs-12';
				break;
			case 3:
				return 'col-lg-4 col-md-4 col-sm-4 col-xs-12';
				break;
			case 4:
				return 'col-lg-3 col-md-3 col-sm-6 col-xs-12';
				break;
			case 6:
				return 'col-lg-2 col-md-2 col-sm-2 col-xs-12';
				break;
		}
		return;
	}
	
	public function getOtherImage($product_related){
		$product_relateds = preg_replace('/(?<=\d),(?=\d{3}\b)/','',$product_related);
		$imgResult = [];
		$objectManager = \Magento\Framework\App\ObjectManager::getInstance();
		$productIdArray = explode(',',$product_relateds);
		foreach($productIdArray as $productId){
			$product = $objectManager->create('Magento\Catalog\Model\Product')->load($productId);
			if($product){
				$images = $product->getMediaGalleryImages();
				if($images){
					foreach($images as $child){
						$imgResult[] = $child->getUrl();
					}
				}
			}
		}
		return $imgResult;
	}
}