<?php

namespace MGS\Portfolio\Setup;

use Magento\Framework\Setup\UpgradeSchemaInterface;
use Magento\Framework\Setup\ModuleContextInterface;
use Magento\Framework\Setup\SchemaSetupInterface;

class UpgradeSchema implements UpgradeSchemaInterface
{
    public function upgrade(SchemaSetupInterface $setup, ModuleContextInterface $context)
    {
        $setup->startSetup();
        if (version_compare($context->getVersion(), '1.0.0.0', '<=')) {
            $setup->getConnection()->addColumn(
                $setup->getTable('mgs_portfolio_items'),
                'related_product',
                [
                    'type' => \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
					'length' => 400,
                    'nullable' => true,
                    'default' => null,
                    'comment' => 'Related Product Portfolio'
                ]
            );
        }
        $setup->endSetup();
    }
}
